Subject: bug#44020: 28.0.50; Prefer selection of colour emoji fonts?

From: Robert Pluim <[email-masked]>
Date: Fri, 16 Oct 2020 12:38:18 +0200

>>>>> On Fri, 16 Oct 2020 13:26:42 +0300, Eli Zaretskii <[email-masked]> said:

    >> From: Robert Pluim <[email-masked]>
    >> Cc: Lars Ingebrigtsen <[email-masked]>,  [email-masked]
    >> Date: Fri, 16 Oct 2020 10:19:12 +0200
    >> 
    >> 1. Deciding what fonts we should use for emoji. We can get a lot of
    >> good results by adding appropriate 'set-fontset-font' calls to
    >> emacs, independently of any other work (I also wonder if we should
    >> change the default of use-default-font-for-symbols, given the
    >> proliferation of both emoji and fonts dedicated to displaying them)
    >> 
    >> 2. Extract the emoji sequences from the Unicode data files and assign
    >> them to a new 'emoji' script. Be prepared to choose your favourite
    >> bikeshed colour.
    >> 
    >> 3. Add the appropriate entries to composition-function-table so that
    >> the various multi-codepoint emoji sequences have a chance to be
    >> rendered correctly, whether by HarfBuzz or the Apple thing whose
    >> name I forget.
    >> 
    >> For [1], I think "Noto Color Emoji" and "Apple Color Emoji" would be a
    >> good start.

    Eli> I agree, but [1] depends on [2], because set-fontset-font needs to
    Eli> know the script.

set-fontset-font with a TARGET covering the emoji codepoints in
question, I meant. Youʼre right itʼs probably cleaner to do both at
the same time.

    Eli> Also, Noto Color Emoji has a free license, so it's okay for it to be
    Eli> in fontset.el, but it is not clear to me whether Apple Color Emoji is
    Eli> distributed under a free license.

Itʼs marked 'Copyright Apple 2011-2016' in the macOS font
selector. And Apple appear to be both sensitive and litigious about
it, so probably best not to promote it.

    >> For [2], I think that was finished, except that Eli then updated Emacs
    >> to the next version of Unicode, and I haven't adjusted yet.

    Eli> "Finished", in the sense that it is in Emacs already?

No, finished as in "it works for me on my mac and GNU/Linux boxes" 🙂

As I said, it needs adjusting to the latest Unicode update.

    >> Iʼll see if I can clean this up this weekend and throw it on a branch.

    Eli> Thanks.

    Eli> FWIW, I think this is good enough to land on master directly, I see no
    Eli> need for a feature branch.

OK.

Robert
--